#pragma once

namespace Tmpl8
{

class Graph
{
public:
	void Update( Surface* screen, float x, float y, int hit, int miss )
	{
		memcpy( &ratio[0], &ratio[1], 99 * sizeof( float ) );
		ratio[99] = min( 1.0f, miss / max( 0.001f, (float)(hit + miss) ) );
		screen->Bar( (int)x, (int)y, (int)x + 99, (int)y + 50, 0xff0000 );
		for (int i = 0; i < 100; i++) if (ratio[i] > 0)
			screen->Line( i + x, y, i + x, y + ratio[i] * 50, 0xff00 );
	}
	float ratio[100] = {};
};

class Game
{
public:
	void SetTarget( Surface* surface ) { screen = surface; }
	void Init();
	void Shutdown() {}
	void VisualizeMem();
	void Tick( float deltaTime );
	void MouseUp( int button ) { /* implement if you want to detect mouse button presses */ }
	void MouseDown( int button ) { /* implement if you want to detect mouse button presses */ }
	void MouseMove( int x, int y ) { /* implement if you want to detect mouse movement */ }
	void KeyUp( int key ) { /* implement if you want to handle keys */ }
	void KeyDown( int key ) { /* implement if you want to handle keys */ }
private:
	Surface* screen;
	MemHierarchy mem;
};

}; // namespace Tmpl8